## tpm tpm |

## Functions

int | gnutls_tpm_get_registered ()
void | gnutls_tpm_key_list_deinit ()
int | gnutls_tpm_key_list_get_url ()
int | gnutls_tpm_privkey_delete ()
int | gnutls_tpm_privkey_generate ()

## Types and Values

#define | GNUTLS_TPM_KEY_SIGNING
#define | GNUTLS_TPM_KEY_USER
#define | GNUTLS_TPM_REGISTER_KEY
typedef | gnutls_tpm_key_list_t
enum | gnutls_tpmkey_fmt_t
struct | tpm_key_list_st

## Description

## Functions

### gnutls_tpm_get_registered ()

    int
    gnutls_tpm_get_registered (gnutls_tpm_key_list_t *list);

This function will get a list of stored keys in the TPM. The uuid of those keys

#### Parameters

list | a list to store the keys |

#### Returns

On success, `GNUTLS_E_SUCCESS` (0) is returned, otherwise a negative error value.

Since: 3.1.0

### gnutls_tpm_key_list_deinit ()

    void
    gnutls_tpm_key_list_deinit (gnutls_tpm_key_list_t list);

This function will deinitialize the list of stored keys in the TPM.

#### Parameters

list | a list of the keys |

Since: 3.1.0

### gnutls_tpm_key_list_get_url ()

    int
    gnutls_tpm_key_list_get_url (gnutls_tpm_key_list_t list,
                                 unsigned int idx,
                                 char **url,
                                 unsigned int flags);

This function will return for each given index a URL of the corresponding key. If the provided index is out of bounds then `GNUTLS_E_REQUESTED_DATA_NOT_AVAILABLE` is returned.

#### Parameters

list | a list of the keys |
idx | The index of the key (starting from zero) |
url | The URL to be returned |
flags | should be zero |

#### Returns

On success, `GNUTLS_E_SUCCESS` (0) is returned, otherwise a negative error value.

Since: 3.1.0

### gnutls_tpm_privkey_delete ()

    int
    gnutls_tpm_privkey_delete (const char *url,
                               const char *srk_password);

This function will unregister the private key from the TPM chip.

#### Parameters

url | the URL describing the key |
srk_password | a password for the SRK key |

#### Returns

On success, `GNUTLS_E_SUCCESS` (0) is returned, otherwise a negative error value.

Since: 3.1.0

### gnutls_tpm_privkey_generate ()

    int
    gnutls_tpm_privkey_generate (gnutls_pk_algorithm_t pk,
                                 unsigned int bits,
                                 const char *srk_password,
                                 const char *key_password,
                                 gnutls_tpmkey_fmt_t format,
                                 gnutls_x509_crt_fmt_t pub_format,
                                 gnutls_datum_t *privkey,
                                 gnutls_datum_t *pubkey,
                                 unsigned int flags);

This function will generate a private key in the TPM chip. The private key will be generated within the chip and will be exported in a wrapped with TPM's master key form. Furthermore the wrapped key can be protected with the provided `password` .

Note that bits in TPM is quantized value. If the input value is not one of the allowed values, then it will be quantized to one of 512, 1024, 2048, 4096, 8192 and 16384.

Allowed flags are:

`GNUTLS_TPM_KEY_SIGNING`: Generate a signing key instead of a legacy,

`GNUTLS_TPM_REGISTER_KEY`: Register the generate key in TPM. In that case `privkey` would contain a URL with the UUID.

#### Parameters

pk | the public key algorithm |
bits | the security bits |
srk_password | a password to protect the exported key (optional) |
key_password | the password for the TPM (optional) |
format | the format of the private key |
pub_format | the format of the public key |
privkey | the generated key |
pubkey | the corresponding public key (may be null) |
flags | should be a list of GNUTLS_TPM_* flags |

#### Returns

On success, `GNUTLS_E_SUCCESS` (0) is returned, otherwise a negative error value.

Since: 3.1.0

## Types and Values

### GNUTLS_TPM_KEY_SIGNING

    #define GNUTLS_TPM_KEY_SIGNING (1<<1)

### GNUTLS_TPM_KEY_USER

    #define GNUTLS_TPM_KEY_USER (1<<3)

### GNUTLS_TPM_REGISTER_KEY

    #define GNUTLS_TPM_REGISTER_KEY (1<<2)

### gnutls_tpm_key_list_t

### enum gnutls_tpmkey_fmt_t

Enumeration of different certificate encoding formats.

#### Members

GNUTLS_TPMKEY_FMT_RAW | The portable data format. |
GNUTLS_TPMKEY_FMT_DER | An alias for the raw format. |
GNUTLS_TPMKEY_FMT_CTK_PEM | A custom data format used by some TPM tools. |

### struct tpm_key_list_st

    struct tpm_key_list_st;